/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.kaaproject.kaa.demo.smarthousedemo.profile;

import java.util.ArrayList;
import java.util.List;

import org.kaa.config.Profile;
import org.kaaproject.kaa.client.profile.AbstractProfileContainer;

import config.system.ProfileProperty;

/** Profile container used to set up endpoint profile */
public class SmartHouseProfileContainer extends AbstractProfileContainer {

    public SmartHouseProfileContainer() {}

    @Override
    public Profile getProfile() {
        List<ProfileProperty> props = new ArrayList<>();
        props.add(new ProfileProperty("propName", "propValue"));
        return new Profile(props);
    }
}
